﻿using UnityEngine;
using System.Collections;

public class Rocket : MonoBehaviour 
{
	public GameObject explosion;		// Prefab of explosion effect.
    public float healthBonus;				// How much health the crate gives the player.

    void Start () 
	{
        healthBonus = 10;
        // Destroy the rocket after 2 seconds if it doesn't get destroyed before then.
        Destroy(gameObject, 2);
	}


	void OnExplode()
	{
		// Create a quaternion with a random rotation in the z-axis.
		Quaternion randomRotation = Quaternion.Euler(0f, 0f, Random.Range(0f, 360f));

		// Instantiate the explosion where the rocket is with the random rotation.
		Instantiate(explosion, transform.position, randomRotation);
	}
	
	void OnTriggerEnter2D (Collider2D col) 
	{
        // Shoots something
        if (col.gameObject.tag != "Player" && col.gameObject.tag != "Player2")
        {
            // Instantiate the explosion and destroy the rocket.
            OnExplode();
            Destroy(gameObject);
        }
        // Shoot player
        else if (col.gameObject.tag == "Player")
        {
            Player1Hit(col);
            // Instantiate the explosion and destroy the rocket.
            OnExplode();
            Destroy(gameObject);
        }
        else if (col.gameObject.tag == "Player2")
        {
            Player2Hit(col);
            // Instantiate the explosion and destroy the rocket.
            OnExplode();
            Destroy(gameObject);
        }
    }
    void Player1Hit(Collider2D col)
    {
        // Get a reference to the player health script.
        PlayerHealth playerHealth = col.GetComponent<PlayerHealth>();

        if (Time.time > playerHealth.lastHealTime + playerHealth.repeatHealPeriod)
        {
            // Increasse the player's health by the health bonus but clamp it at 100.
            playerHealth.health += healthBonus;
            playerHealth.health = Mathf.Clamp(playerHealth.health, 0f, 100f);

            playerHealth.lastHealTime = Time.time;
        }
        // Update the health bar.
        playerHealth.UpdateHealthBar();
    }

    void Player2Hit(Collider2D col)
    {
        // Get a reference to the player health script.
        PlayerHealth2 playerHealth2 = col.GetComponent<PlayerHealth2>();

        if (Time.time > playerHealth2.lastHealTime + playerHealth2.repeatHealPeriod)
        {
            // Increasse the player's health by the health bonus but clamp it at 100.
            playerHealth2.health += healthBonus;
            playerHealth2.health = Mathf.Clamp(playerHealth2.health, 0f, 100f);

            playerHealth2.lastHealTime = Time.time;
        }
        // Update the health bar.
        playerHealth2.UpdateHealthBar();
    }
}


